#include "stdafx.h"
#include "AntiPwdSpy.h"
#include "ChangeCredentialsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//***********************************************
CChangeCredentialsDlg::CChangeCredentialsDlg(CWnd *pParent)
	: CDialog(CChangeCredentialsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeCredentialsDlg)
	m_strPassword = _T("");
	m_strUsername = _T("");
	m_strPasswordConfirm = _T("");
	//}}AFX_DATA_INIT
	m_bPwdChanged = false;
}

//***********************************************
void CChangeCredentialsDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeCredentialsDlg)
	DDX_Text(pDX, IDC_EDIT_PASSWORD, m_strPassword);
	DDX_Text(pDX, IDC_EDIT_USERNAME, m_strUsername);
	DDX_Text(pDX, IDC_EDIT_PASSWORD_CONFIRM, m_strPasswordConfirm);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChangeCredentialsDlg, CDialog)
	//{{AFX_MSG_MAP(CChangeCredentialsDlg)
	ON_EN_CHANGE(IDC_EDIT_PASSWORD, OnChangePassword)
	ON_EN_CHANGE(IDC_EDIT_PASSWORD_CONFIRM, OnChangePasswordConfirm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//***********************************************
BOOL CChangeCredentialsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// If both a username and password are specified, fill the two password fields
	// with the bogus password instead of the real password.
	if(!m_strUsername.IsEmpty() && !m_strHiddenPassword.IsEmpty())
	{
		m_strPassword = m_strPasswordConfirm = g_szBogusPassword;
		UpdateData(FALSE);
	}

	return TRUE;
}

//***********************************************
void CChangeCredentialsDlg::OnOK()
{
	UpdateData();

	// Check if the two passwords match
	if(m_strPassword.Compare(m_strPasswordConfirm) != 0)
	{	// The password do not match; warn the user, clear the passwords, and set focus to the first one
		AfxMessageBox(IDS_PASSWORD_DONT_MATCH, MB_OK | MB_ICONEXCLAMATION);
		GetDlgItem(IDC_EDIT_PASSWORD)->SetWindowText(_T(""));
		GetDlgItem(IDC_EDIT_PASSWORD_CONFIRM)->SetWindowText(_T(""));
		GetDlgItem(IDC_EDIT_PASSWORD)->SetFocus();
		return;
	}

	// This copies the password (if changed) into the hidden password field
	UpdateHiddenPassword();

	CDialog::OnOK();
}

//***********************************************
void CChangeCredentialsDlg::OnChangePassword()
{
	m_bPwdChanged = true;
}

//***********************************************
void CChangeCredentialsDlg::OnChangePasswordConfirm()
{
	m_bPwdChanged = true;
}

//***********************************************
void CChangeCredentialsDlg::UpdateHiddenPassword(void)
{
	if(m_bPwdChanged)
	{
		_ASSERTE(!m_strPassword.Compare(m_strPasswordConfirm));
		m_strHiddenPassword = m_strPassword;
	}
}
