#pragma once

#include "resource.h"

typedef bool (*LPFNINSTALLHOOK)(const DWORD);
typedef bool (*LPFNREMOVEHOOK)(void);
typedef bool (*LPFNSCANPASSWORD)(const HWND, const HWND);

//***********************************************
class CHookDllInterface
{
public:
	CHookDllInterface();
	virtual ~CHookDllInterface();

	bool InstallHook(const DWORD dwThreadId);
	bool RemoveHook(void);
	bool ScanPassword(const HWND hWnd, const HWND hPwdSpyWnd);

protected:
	HMODULE m_hModHookDll;
	LPFNINSTALLHOOK m_lpfnInstallHook;
	LPFNREMOVEHOOK m_lpfnRemoveHook;
	LPFNSCANPASSWORD m_lpfnScanPassword;

	static bool ExtractResource(const HINSTANCE hInstance, const WORD nID, LPCTSTR szFilename);
};
